"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var commander = require("commander");
var config_1 = require("./config");
var run_1 = require("./commands/run");
var pkg = require('../package.json');
process.title = 'code-to-json';
var actionInvoked = false;
var prog = commander
    .version(pkg.version)
    .name('code-to-json')
    .arguments('<entries...>')
    .description('a thing')
    .option('-c,--config <path>', 'path to tsconfig.json')
    .option('-o,--out <path>', 'output path')
    .action(function (entries) {
    actionInvoked = true;
    setTimeout(function () {
        var allOpts = __assign({ entries: entries }, prog.opts());
        var validationResult = config_1.validateConfig(allOpts);
        if (validationResult[0] === 'error') {
            prog.outputHelp();
            throw validationResult[1];
        }
        else {
            var cfg = validationResult[1];
            console.log('Valid config!', cfg);
            run_1.default(cfg.entries, cfg.out, cfg.configPath);
        }
    }, 0);
})
    .parse(process.argv);
if (!actionInvoked) {
    setTimeout(function () {
        console.log(prog.help());
        process.exit(1);
    }, 0);
}
//# sourceMappingURL=index.js.map